#ifndef ELM_FLIP_INTERNAL_PART_EO_HH
#define ELM_FLIP_INTERNAL_PART_EO_HH
#include <Eo.h>

extern "C" {
#include "efl_container.eo.h"
#include "efl_gfx.eo.h"
#include "efl_object.eo.h"
#include "elm_flip_internal_part.eo.h"
}
#include <Eina.hh>
#include <Eo.hh>
#include "efl_container.eo.hh"
#include "efl_gfx.eo.hh"
#include "efl_object.eo.hh"
namespace elm { namespace flip { namespace internal { 
struct Part;
} } } 
namespace efl { namespace eo { template<> struct is_eolian_object< ::elm::flip::internal::Part> : ::std::true_type {}; } }
namespace elm { namespace flip { namespace internal { 
struct Part;
} } } 
namespace efl { 
struct Object;
} 
namespace efl { 
struct Container;
} 
namespace efl { 
struct Gfx;
} 

namespace eo_cxx {
namespace elm { namespace flip { namespace internal { 
struct Part {
   static Efl_Class const* _eo_class()
   {
      return ELM_FLIP_INTERNAL_PART_CLASS;
   }
   Eo* _eo_ptr() const { return *(Eo**)this; }
   operator ::elm::flip::internal::Part() const;
   operator ::elm::flip::internal::Part&();
   operator ::elm::flip::internal::Part const&() const;
   /// @cond LOCAL
    ::efl::eolian::address_of_operator<Part,  ::efl::Container,  ::efl::Gfx,  ::efl::Object> operator&() { return {this}; }
    ::efl::eolian::address_of_operator<Part const ,  ::efl::Container const ,  ::efl::Gfx const ,  ::efl::Object const > operator&() const { return {this}; }
   /// @endcond
};
} } } 
}
namespace elm { namespace flip { namespace internal { 
struct Part : ::efl::eo::concrete
   , EO_CXX_INHERIT( ::efl::Container)
   , EO_CXX_INHERIT( ::efl::Gfx)
   , EO_CXX_INHERIT( ::efl::Object)
{
   explicit Part( ::Eo* eo)
      : ::efl::eo::concrete(eo) {}
   explicit Part(std::nullptr_t)
      : ::efl::eo::concrete(nullptr) {}
   Part(Part const& other) = default;
   Part(Part&& other) = default;
   Part& operator=(Part const& other) = default;
   Part& operator=(Part&& other) = default;
   Part()
   {
      ::efl::eolian::do_eo_add( ::efl::eo::concrete::_eo_raw, ::efl::eo::concrete{nullptr}, _eo_class());
   }
   Part( ::efl::eo::concrete parent)
   {
      ::efl::eolian::do_eo_add( ::efl::eo::concrete::_eo_raw, parent, _eo_class());
   }
   template <typename F> Part(F f, typename ::std::enable_if< ::efl::eolian::is_callable<F>::value>::type* = 0)
   {
      ::efl::eolian::do_eo_add( ::efl::eo::concrete::_eo_raw, ::efl::eo::concrete{nullptr}, _eo_class(), f);
   }
   static Efl_Class const* _eo_class()
   {
      return ELM_FLIP_INTERNAL_PART_CLASS;
   }
   Eo* _eo_ptr() const { return *(Eo**)this; }
   /// @cond LOCAL
    ::efl::eolian::address_of_operator<Part,  ::efl::Container,  ::efl::Gfx,  ::efl::Object> operator&() { return {this}; }
    ::efl::eolian::address_of_operator<Part const ,  ::efl::Container const ,  ::efl::Gfx const ,  ::efl::Object const > operator&() const { return {this}; }
   /// @endcond
};
static_assert(sizeof(Part) == sizeof(Eo*), "");
static_assert(std::is_standard_layout<Part>::value, "");
} } } 
#endif
